orte/mca/pls/bproc/pls_bproc.h File Reference.TH "orte/mca/pls/bproc/pls_bproc.h" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
orte/mca/pls/bproc/pls_bproc.h \- Header file for the bproc launcher. 
.SH SYNOPSIS
.br
.PP
\fC#include 'orte_config.h'\fP
.br
\fC#include 'orte/class/orte_pointer_array.h'\fP
.br
\fC#include 'orte/include/orte_constants.h'\fP
.br
\fC#include 'orte/mca/pls/base/base.h'\fP
.br
\fC#include 'orte/util/proc_info.h'\fP
.br
\fC#include 'opal/threads/condition.h'\fP
.br
\fC#include <sys/bproc.h>\fP
.br

.SS "Typedefs"

.in +1c
.ti -1c
.RI "typedef \fBorte_pls_bproc_component_t\fP \fBorte_pls_bproc_component_t\fP"
.br
.RI "\fIConvenience typedef. \fP"
.in -1c
.SS "Functions"

.in +1c
.ti -1c
.RI "int \fBorte_pls_bproc_component_open\fP (void)"
.br
.RI "\fIOpens the pls_bproc component, setting all the needed mca parameters and finishes setting up the component struct. \fP"
.ti -1c
.RI "int \fBorte_pls_bproc_component_close\fP (void)"
.br
.RI "\fICloses the pls_bproc component. \fP"
.ti -1c
.RI "\fBorte_pls_base_module_t\fP * \fBorte_pls_bproc_init\fP (int *priority)"
.br
.RI "\fIInitializes the module. \fP"
.ti -1c
.RI "int \fBorte_pls_bproc_finalize\fP (void)"
.br
.RI "\fIModule cleanup. \fP"
.ti -1c
.RI "int \fBorte_pls_bproc_launch\fP (\fBorte_jobid_t\fP)"
.br
.RI "\fIThe main bproc launcher. \fP"
.ti -1c
.RI "int \fBorte_pls_bproc_terminate_job\fP (\fBorte_jobid_t\fP)"
.br
.RI "\fITerminate all processes associated with this job - including daemons. \fP"
.ti -1c
.RI "int \fBorte_pls_bproc_terminate_proc\fP (const orte_process_name_t *proc_name)"
.br
.RI "\fITerminate a specific process. \fP"
.in -1c
.SS "Variables"

.in +1c
.ti -1c
.RI "ORTE_DECLSPEC \fBorte_pls_bproc_component_t\fP \fBmca_pls_bproc_component\fP"
.br
.RI "\fIThe bproc component data structure used to store all the relevent data about this component. \fP"
.ti -1c
.RI "ORTE_DECLSPEC \fBorte_pls_base_module_t\fP \fBorte_pls_bproc_module\fP"
.br
.RI "\fIInitialization of the bproc module with all the needed function pointers. \fP"
.in -1c
.SH "Detailed Description"
.PP 
Header file for the bproc launcher. 

This launcher is actually split into 2 modules: pls_bproc & pls_bproc_orted. The general idea behind this launcher is:
.IP "1." 4
pls_bproc is called by orterun. It figures out the process mapping and launches orted's on the nodes
.IP "2." 4
pls_bproc_orted is called by orted. This module intializes either a pty or pipes, places symlinks to them in well know points of the filesystem, and sets up the io forwarding. It then sends an ack back to orterun.
.IP "3." 4
pls_bproc waits for an ack to come back from the orteds, then does several parallel launches of the application processes. The number of launches is equal to the maximum number of processes on a node. For example, if there were 2 processes assigned to node 1, and 1 process asigned to node 2, we would do a parallel launch that launches on process on each node, then another which launches another process on node 1.
.PP

.SH "Function Documentation"
.PP 
.SS "\fBorte_pls_base_module_t\fP* orte_pls_bproc_init (int * priority)"
.PP
Initializes the module. 
.PP
We do not want to run unless we are the seed, bproc is running, and we are the master node. 
.SS "int orte_pls_bproc_launch (\fBorte_jobid_t\fP jobid)"
.PP
The main bproc launcher. 
.PP
See \fBpls_bproc.h\fP for a high level overview of how the bproc launching works. Here we:
.IP "1." 4
Launch the deamons on the backend nodes.
.IP "2." 4
The daemons setup files for io forwarding then connect back to us to tells us they are ready for the actual apps.
.IP "3." 4
Launch the apps on the backend nodes
.PP
.PP
\fBParameters:\fP
.RS 4
\fIjobid\fP the jobid of the job to launch 
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIORTE_SUCCESS\fP .br
\fIerror\fP .RE
.PP

.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
